VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "msflxgrd.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3000
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8805
   LinkTopic       =   "Form1"
   ScaleHeight     =   3000
   ScaleWidth      =   8805
   StartUpPosition =   3  'Windows Default
   Begin MSFlexGridLib.MSFlexGrid MSFlexGrid1 
      Height          =   1935
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2535
      _ExtentX        =   4471
      _ExtentY        =   3413
      _Version        =   393216
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' The column selected for sorting.
Private m_SortColumn As Integer

' The current sort order.
Private m_SortOrder As SortSettings
' Size the columns for the biggest member.
Private Sub SizeColumns()
Dim row_num As Integer
Dim col_num As Integer
Dim max_width As Single

    For col_num = 0 To MSFlexGrid1.Cols - 1
        max_width = 0
        For row_num = 0 To MSFlexGrid1.Rows - 1
            If max_width < TextWidth(MSFlexGrid1.TextMatrix(row_num, col_num)) Then
                max_width = TextWidth(MSFlexGrid1.TextMatrix(row_num, col_num))
            End If
        Next row_num
        MSFlexGrid1.ColWidth(col_num) = max_width + 240
    Next col_num
End Sub

Private Sub MSFlexGrid1_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    ' If this is not row 0, do nothing.
    If MSFlexGrid1.MouseRow <> 0 Then Exit Sub

    ' Sort by the clicked column.
    SortByColumn MSFlexGrid1.MouseCol
End Sub
' Sort by the indicated column.
Private Sub SortByColumn(ByVal sort_column As Integer)
    ' Hide the FlexGrid.
    MSFlexGrid1.Visible = False
    MSFlexGrid1.Refresh

    ' Sort using the clicked column.
    MSFlexGrid1.Col = sort_column
    MSFlexGrid1.ColSel = sort_column
    MSFlexGrid1.Row = 0
    MSFlexGrid1.RowSel = 0

    ' If this is a new sort column, sort ascending.
    ' Otherwise switch which sort order we use.
    If m_SortColumn <> sort_column Then
        m_SortOrder = flexSortGenericAscending
    ElseIf m_SortOrder = flexSortGenericAscending Then
        m_SortOrder = flexSortGenericDescending
    Else
        m_SortOrder = flexSortGenericAscending
    End If
    MSFlexGrid1.Sort = m_SortOrder

    ' Restore the previous sort column's name.
    If m_SortColumn >= 0 Then
        MSFlexGrid1.TextMatrix(0, m_SortColumn) = Mid$(MSFlexGrid1.TextMatrix(0, m_SortColumn), 3)
    End If

    ' Display the new sort column's name.
    m_SortColumn = sort_column
    If m_SortOrder = flexSortGenericAscending Then
        MSFlexGrid1.TextMatrix(0, m_SortColumn) = "> " & MSFlexGrid1.TextMatrix(0, m_SortColumn)
    Else
        MSFlexGrid1.TextMatrix(0, m_SortColumn) = "< " & MSFlexGrid1.TextMatrix(0, m_SortColumn)
    End If

' Debug.Print sort_column; MSFlexGrid1.Col; m_SortColumn '@

    ' Display the FlexGrid.
    MSFlexGrid1.Visible = True
End Sub

' Add a row to the FlexGrid control.
Private Sub AddRow(ByVal values As Variant)
Static next_row As Integer

Dim next_col As Integer

    MSFlexGrid1.Rows = next_row + 1

    For next_col = 0 To UBound(values)
        MSFlexGrid1.TextMatrix(next_row, next_col) = values(next_col)
    Next next_col

    next_row = next_row + 1
End Sub
Private Sub Form_Load()
    MSFlexGrid1.AllowUserResizing = flexResizeColumns

    ' Make some data.
    MSFlexGrid1.Cols = 5
    AddRow Array("Title", "Year", "Pages", "URL", "ISBN")
    AddRow Array("Microsoft Office Programming", "2003", "712", "http://www.vb-helper.com/office.htm", " 1-59059-121-6")
    AddRow Array("Visual Basic .NET and XML", "2002", "503", "http://www.vb-helper.com/xml.htm", " 0-471-12060-X")
    AddRow Array("Visual Basic Graphics Programming", "2000", "712", "http://www.vb-helper.com/vbgp.htm", " 0-471-35599-2")
    AddRow Array("Ready-to-Run Visual Basic Code Library", "1999", "424", "http://www.vb-helper.com/vbcl.htm", " 0-471-33345-X")
    AddRow Array("Bug Proofing Visual Basic", "1999", "397", "http://www.vb-helper.com/err.htm", " 0-471-32351-9")
    AddRow Array("Ready-to-Run Delphi Algorithms", "1998", "398", "http://www.vb-helper.com/da.htm", " 0-471-25400-2")
    AddRow Array("Ready-to-Run Visual Basic Algorithms", "1998", "395", "http://www.vb-helper.com/vba.htm", " 0-471-24268-3")
    AddRow Array("Custom Controls Library", "1998", "684", "http://www.vb-helper.com/ccl.htm", " 0-471-24267-5")
    AddRow Array("Advanced Visual Basic Techniques", "1997", "440", "http://www.vb-helper.com/avbt.htm", " 0-471-18881-6")

    MSFlexGrid1.FixedCols = 0
    MSFlexGrid1.FixedRows = 1

    ' Size the columns.
    SizeColumns

    ' Start with no column sorted.
    m_SortColumn = -1
End Sub

Private Sub Form_Resize()
    MSFlexGrid1.Move 0, 0, ScaleWidth, ScaleHeight
End Sub
